<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   close="titlewindowCloseHandler(event)" 
			   creationComplete="creationCompleteHandler(event)" 
			   title="Pesquisa de Log Recebimento Parcela" 
			   xmlns:visual="br.com.desenv.framework.component.visual.*"
			   maxWidth="1200" maxHeight="700" 
			    xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	
	
	<fx:Metadata>
		[Event(name="LogRecebimentoParcelaSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.controls.DateField;
			import mx.validators.Validator;
			import spark.events.TitleWindowBoundsEvent;
			
			
			import br.com.desenv.nepalign.vo.Page;
			import br.com.desenv.nepalign.vo.LogRecebimentoParcela;

			import br.com.desenv.nepalign.vo.Usuario;
			import br.com.desenv.nepalign.vo.EmpresaFisica;
			import br.com.desenv.nepalign.vo.Cliente;
			
			[Bindable]
			public var listaLogRecebimentoParcela: ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			private var totalRecords: int;
			private var pageSize: int = 15;
			private var lastPage: int = 1;
			
			[Bindable]
			private var listaUsuarioPesquisa: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaEmpresaFisicaPesquisa: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaClientePesquisa: ArrayCollection = new ArrayCollection();

			private var cliente: Cliente;
			
			private var logRecebimentoParcelaComponenteDetalhe: LogRecebimentoParcelaComponenteDetalhe;

			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}

			private function montarObjetoFiltro(): LogRecebimentoParcela
			{
				var logRecebimentoParcelaFiltro: LogRecebimentoParcela = new LogRecebimentoParcela();
				
				logRecebimentoParcelaFiltro.motivo = ignTextInputMotivoPesquisa.text == ""?null:ignTextInputMotivoPesquisa.text;
				logRecebimentoParcelaFiltro.data = ignTextInputDateDataPesquisa.text == ""?null:DateField.stringToDate(ignTextInputDateDataPesquisa.text, "DD/MM/YYYY");
				logRecebimentoParcelaFiltro.valorSelecionado =  ignTextInputDoubleValorSelecionadoPesquisa.text == ""?NaN:parseFloat(ignTextInputDoubleValorSelecionadoPesquisa.text);
				logRecebimentoParcelaFiltro.valorInformado =  ignTextInputDoubleValorInformadoPesquisa.text == ""?NaN:parseFloat(ignTextInputDoubleValorInformadoPesquisa.text);
				//logRecebimentoParcelaFiltro.cliente = this.cliente;	
				logRecebimentoParcelaFiltro.cliente = ignAutoCompleteClientePesquisa.itemSelecionado as Cliente;			
							
				logRecebimentoParcelaFiltro.empresaFisica = ignComboBoxAutoCompleteEmpresaFisicaPesquisa.selectedItem; 
				return logRecebimentoParcelaFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void {
				carregarListaValidacao();
				
				var remoteObjectLogRecebimentoParcela: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logRecebimentoParcelaService", listarResultHandler);	
				
				var remoteObjectEmpresaFisica: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("empresaFisicaService", listarEmpresaFisicaPesquisaResultHandler);	
				remoteObjectEmpresaFisica.getOperation("listar").send();
				
				var logRecebimentoParcelaFiltro: LogRecebimentoParcela = new LogRecebimentoParcela();
				remoteObjectLogRecebimentoParcela.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, logRecebimentoParcelaFiltro); 
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- RETORNO DA FUNCAO LISTAR  --------------------------------	
			
			private function listarResultHandler( event: ResultEvent ): void {
				var paginaLogRecebimentoParcela: Page = event.result as Page;
				pageNumber = paginaLogRecebimentoParcela.pageNumber;
				totalRecords = paginaLogRecebimentoParcela.totalRecords;
				lastPage = paginaLogRecebimentoParcela.lastPage();
				listaLogRecebimentoParcela = paginaLogRecebimentoParcela.recordList;
				labelPaginaAtual.text = "" + paginaLogRecebimentoParcela.pageNumber;
				labelTotalRegistro.text = "Total de Registros " + paginaLogRecebimentoParcela.totalRecords;
			}

// CARREGANDO COMBOS			
			private function listarEmpresaFisicaPesquisaResultHandler( event: ResultEvent ): void 
			{
				listaEmpresaFisicaPesquisa = event.result as ArrayCollection;
				listaEmpresaFisicaPesquisa.addItemAt(null, 0);
			}

// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
			protected function buttonPesquisarClientePesquisa_clickHandler(event:MouseEvent):void
			{
				var clienteComponentePesquisa: ClienteComponentePesquisa = new ClienteComponentePesquisa();
				clienteComponentePesquisa.addEventListener("ClienteSelecionadoEvent", atualizarClientePesquisaPorSelecaoResultHandler);
				UPCPopUpManager.instance.addPopUp(clienteComponentePesquisa, this, true);
				UPCPopUpManager.instance.centerWindow(clienteComponentePesquisa);
			}
			
			private function atualizarClientePesquisaPorSelecaoResultHandler(e:ResultEvent):void
			{
				var novoCliente: Cliente = e.result as Cliente;
				ignAutoCompleteClientePesquisa.itemSelecionado = novoCliente;
			}
	
			
			
// -------------FUNCAO DE FILTRAR  -------------------------------------------------------			

			private function buttonFiltrarClickHandler( event: MouseEvent ): void {
				if (validar(event))
				{
					var remoteObjectLogRecebimentoParcela: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logRecebimentoParcelaService", listarResultHandler);	
					remoteObjectLogRecebimentoParcela.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				}	 
			}
			
// -------------FUNCOES DE INSERIR E ATUALIZAR  -------------------------------------------------------			

			private function buttonInserir_clickHandler( event: MouseEvent): void 
			{
				var logRecebimentoParcelaComponenteCadastro: LogRecebimentoParcelaComponenteCadastro = new LogRecebimentoParcelaComponenteCadastro();
				logRecebimentoParcelaComponenteCadastro.logRecebimentoParcela = new LogRecebimentoParcela(); 
				logRecebimentoParcelaComponenteCadastro.addEventListener("LogRecebimentoParcelaIncluidoEvent", atualizarListaLogRecebimentoParcelaPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(logRecebimentoParcelaComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(logRecebimentoParcelaComponenteCadastro);
			}
			
			protected function buttonFechar_clickHandler(event:MouseEvent):void
			{
				var logRecebimentoParcelaSelecionado: LogRecebimentoParcela = datagridListaLogRecebimentoParcela.selectedItem as LogRecebimentoParcela;
				this.dispatchEvent(new ResultEvent("LogRecebimentoParcelaSelecionadoEvent",false, true, logRecebimentoParcelaSelecionado, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function datagridListaLogRecebimentoParcela_doubleClickHandler(event:MouseEvent):void
			{
				logRecebimentoParcelaComponenteDetalhe = new LogRecebimentoParcelaComponenteDetalhe();
				logRecebimentoParcelaComponenteDetalhe.logRecebimentoParcela = datagridListaLogRecebimentoParcela.selectedItem as LogRecebimentoParcela;
				logRecebimentoParcelaComponenteDetalhe.addEventListener("LogRecebimentoParcelaExcluidoEvent", atualizarListaLogRecebimentoParcelaPorExclusaoResultHandler);
				logRecebimentoParcelaComponenteDetalhe.addEventListener("LogRecebimentoParcelaAtualizadoEvent", atualizarListaLogRecebimentoParcelaPorAtualizacaoResultHandler);
				UPCPopUpManager.instance.addPopUp(logRecebimentoParcelaComponenteDetalhe, this, true);
				UPCPopUpManager.instance.centerWindow(logRecebimentoParcelaComponenteDetalhe);
			}
			
			
			private function atualizarListaLogRecebimentoParcelaPorInclusaoResultHandler(e:Event):void
			{
				var remoteObjectLogRecebimentoParcela: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logRecebimentoParcelaService", listarResultHandler);	
				remoteObjectLogRecebimentoParcela.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro()); 
			}
			
			private function atualizarListaLogRecebimentoParcelaPorAtualizacaoResultHandler(e:Event):void
			{
				var remoteObjectLogRecebimentoParcela: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logRecebimentoParcelaService", listarResultHandler);	
				remoteObjectLogRecebimentoParcela.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
				
			}
			
			
			private function atualizarListaLogRecebimentoParcelaPorExclusaoResultHandler(e:Event):void
			{
				var remoteObjectLogRecebimentoParcela: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logRecebimentoParcelaService", listarResultHandler);	
				remoteObjectLogRecebimentoParcela.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
			}
			
			
			
			
		
// -------------FUNCOES DE NAVEGACAO -------------------------------------------------------			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectLogRecebimentoParcela: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logRecebimentoParcelaService", listarResultHandler);	

				if (pageNumber < lastPage)
				{
					remoteObjectLogRecebimentoParcela.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber + 1), montarObjetoFiltro());
				}
				else
				{
					remoteObjectLogRecebimentoParcela.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro());
				}				
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectLogRecebimentoParcela: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logRecebimentoParcelaService", listarResultHandler);	
				
				if (pageNumber > 1)
				{
					remoteObjectLogRecebimentoParcela.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber - 1) , montarObjetoFiltro());
				}
				else
				{
					remoteObjectLogRecebimentoParcela.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro());
				}
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectLogRecebimentoParcela: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logRecebimentoParcelaService", listarResultHandler);	
				remoteObjectLogRecebimentoParcela.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro()); 
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectLogRecebimentoParcela: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("logRecebimentoParcelaService", listarResultHandler);	
				remoteObjectLogRecebimentoParcela.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage , montarObjetoFiltro()); 
			}
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
			
	</fx:Declarations>
	
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Motivo:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoMotivoPesquisa" styleName="labelValidacao" text="{ignTextInputMotivoPesquisa.errorString}"/>
					<visual:IgnTextInput id="ignTextInputMotivoPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Data:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDataPesquisa" styleName="labelValidacao" text="{ignTextInputDateDataPesquisa.errorString}"/>
					<visual:IgnTextInputDate id="ignTextInputDateDataPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>


		</mx:GridRow>
		<mx:GridRow>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Valor Selecionado:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoValorSelecionadoPesquisa" styleName="labelValidacao" text="{ignTextInputDoubleValorSelecionadoPesquisa.errorString}"/>
					<visual:IgnTextInputDouble id="ignTextInputDoubleValorSelecionadoPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>


		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Valor Informado:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoValorInformadoPesquisa" styleName="labelValidacao" text="{ignTextInputDoubleValorInformadoPesquisa.errorString}"/>
					<visual:IgnTextInputDouble id="ignTextInputDoubleValorInformadoPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Cliente:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoClientePesquisa" styleName="labelValidacao" text="{ignAutoCompleteClientePesquisa.errorString}"/>
					<s:HGroup>
						<autoComplete:IgnAutoComplete idKeyName="id" palavraChave="nome" id="ignAutoCompleteClientePesquisa" enviarArgumentos="true" destino="clienteService" funcaoChamada="listarPorObjetoFiltro" lenStartConsulta="3"  nomeClasseObjetoFiltro="br.com.desenv.nepalign.vo.Cliente" tabEnabled="true" />  
						<s:Button id="buttonPesquisarClientePesquisa" width="30" label="..." click="buttonPesquisarClientePesquisa_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>


		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Empresa:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoEmpresaFisicaPesquisa" styleName="labelValidacao" text="{ignComboBoxAutoCompleteEmpresaFisicaPesquisa.errorString}"/>
					<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteEmpresaFisicaPesquisa" dataProvider="{listaEmpresaFisicaPesquisa}" labelField="razaoSocial" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>		



 			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="right">
				<mx:Button id="buttonFiltrar" label="Filtrar" click="buttonFiltrarClickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4">
				<s:Spacer/>	
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				
				
				<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
				<mx:Label id="labelPaginaAtual" text=""/>
				<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:DataGrid id="datagridListaLogRecebimentoParcela"  width="100%" verticalScrollPolicy="on" horizontalScrollPolicy="on" dataProvider="{listaLogRecebimentoParcela}" doubleClick="datagridListaLogRecebimentoParcela_doubleClickHandler(event)" doubleClickEnabled="true">
					<mx:columns>
						<mx:DataGridColumn visible="false" dataField="id"/>
						<mx:DataGridColumn dataField="motivo" headerText="Motivo" resizable="true"/>
						<mx:DataGridColumn dataField="data" headerText="Data" resizable="true" labelFunction="DsvObjectUtil.formatDate"/>
						<mx:DataGridColumn dataField="usuario.login" headerText="Usuário" resizable="true"/>
						<mx:DataGridColumn dataField="valorSelecionado" headerText="Valor Selecionado" resizable="true"/>
						<mx:DataGridColumn dataField="valorInformado" headerText="Valor Informado" resizable="true"/>
						<mx:DataGridColumn dataField="cliente.nome" headerText="Cliente" resizable="true"/>
<!--
						<mx:DataGridColumn dataField="empresaFisica.razaoSocial" headerText="Empresa" resizable="true"/>
-->
					</mx:columns>
				</mx:DataGrid>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			
			<mx:GridItem colSpan="2" horizontalAlign="left">
				<mx:Label id="labelTotalRegistro" text=""/>
			</mx:GridItem>
			<mx:GridItem colSpan="2" horizontalAlign="right">
				<mx:Button id="buttonInserir" label="Novo" click="buttonInserir_clickHandler(event)"/>
				<mx:Button id="buttonFechar" label="Fechar" click="buttonFechar_clickHandler(event)"/>
			</mx:GridItem>	
		</mx:GridRow>
				
	</mx:Grid>
</s:TitleWindow>
